--
-- Fix Script for Defect S1202073 
-- Update SharedServices sas_keygen values for workflow tables to fix DuplicateKeyException when starting a workflow
--  
-- This script can be run post-install if/when the DuplicateKeyException is observed when starting a workflow
-- or seen in the <!SASConfig><Level>\Logs\Configure\spmmidtier_loadContent installation log  for the [loadWorkflows] task
--
--
-- This sql update script can be run using the pgAdmin III or psql command line to update the SharedServices db
-- PostgreSQL Interactive Terminal reference: 
-- http://www.postgresql.org/docs/9.0/static/app-psql.html 
--
--
-- Upload/copy this file to a directory, open a command prompt or shell window, 
-- cd into it and run the following command to connect to the database
-- Replace your.host.datatier.com with the datatier hostname.  
-- The database port and owner in your installation may be different than the defaults shown here.
--
-- psql -d SharedServices -h your.host.datatier.com -p 9432 -U dbmsowner < fix_sharedservices_workflow_keygen.sql
-- Provide user password when prompted 
--
-- Restart the following SAS Web Application Servers: 
--   SASServer1_1   where workflow is deployed 
--   SASServer11_1  where Strategy Management is deployed
--   any other SAS Web Application Server dependent upon SASServer1_1
-- 

UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_process) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wfprocess';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_operand) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wfoperand';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_status) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wfstatus';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_policy) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wfpolicy';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_process_ace) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wface';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_conditional_change) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wfconditionalchange';


UPDATE sas_keygen
SET key_cnt=subquery.maxid+1
FROM (SELECT COALESCE(MAX(real_id), 0) AS maxid FROM sas_wf_timerspec) AS subquery
WHERE sas_keygen.identifier_cd='sasapp/wftimerspec';




